/*=====================================================================
File: PrefColorsPage.cs

Summary: 

Date : Fev 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) N/A
=====================================================================*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace OpenCellar.AddIn.AlternateColorGrid
{
	/// <summary>
	/// PrefColorsPage.
	/// </summary>
	public class PrefColorsPage : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button color1;
		private System.Windows.Forms.Button color2;
		private System.Windows.Forms.Button apply;
		private System.Windows.Forms.Label viewColor1;
		private System.Windows.Forms.Label viewColor2;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Initialise une instance de classe PrefColorsPage.
		/// </summary>
		/// <param name="color1"></param>
		/// <param name="color2"></param>
		public PrefColorsPage()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//
			apply.Click+=new EventHandler(OnSave);
			color1.Click+=new EventHandler(OnChooseColor1);
			color2.Click+=new EventHandler(OnChooseColor2);
		}

		private Color m_color1 = Color.Empty;

		/// <summary>
		/// Obtient ou dfinit la couleur de ligne.
		/// </summary>
		public Color Color1
		{
			get
			{
				return(m_color1);
			}
			set
			{
				if(m_color1 != value)
				{
					m_color1 = value;
					viewColor1.BackColor = m_color1;
				}
			}
		}

		private Color m_color2 = Color.Empty;

		/// <summary>
		/// Obtient ou dfinit la couleur alternative.
		/// </summary>
		public Color Color2
		{
			get
			{
				return(m_color2);
			}
			set
			{
				if(m_color2 != value)
				{
					m_color2 = value;
					viewColor2.BackColor = m_color2;
				}
			}
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Affiche la boite de dialogue de selection de la couleur.
		/// </summary>
		/// <param name="selectedColor"></param>
		/// <returns></returns>
		private Color ShowColorDialog(Color selectedColor)
		{
			Color c = Color.Empty;

			using(ColorDialog cd = new ColorDialog())
			{
				cd.Color = selectedColor;
				if(cd.ShowDialog(this) == DialogResult.OK)
				{
					c = cd.Color;
				}
			}

			return(c);
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.color1 = new System.Windows.Forms.Button();
			this.viewColor1 = new System.Windows.Forms.Label();
			this.viewColor2 = new System.Windows.Forms.Label();
			this.color2 = new System.Windows.Forms.Button();
			this.apply = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// color1
			// 
			this.color1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.color1.Location = new System.Drawing.Point(96, 32);
			this.color1.Name = "color1";
			this.color1.Size = new System.Drawing.Size(112, 23);
			this.color1.TabIndex = 0;
			this.color1.Text = "Couleur ligne 1";
			// 
			// viewColor1
			// 
			this.viewColor1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.viewColor1.Location = new System.Drawing.Point(24, 24);
			this.viewColor1.Name = "viewColor1";
			this.viewColor1.Size = new System.Drawing.Size(48, 48);
			this.viewColor1.TabIndex = 1;
			// 
			// viewColor2
			// 
			this.viewColor2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.viewColor2.Location = new System.Drawing.Point(24, 80);
			this.viewColor2.Name = "viewColor2";
			this.viewColor2.Size = new System.Drawing.Size(48, 48);
			this.viewColor2.TabIndex = 3;
			// 
			// color2
			// 
			this.color2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.color2.Location = new System.Drawing.Point(96, 88);
			this.color2.Name = "color2";
			this.color2.Size = new System.Drawing.Size(112, 23);
			this.color2.TabIndex = 2;
			this.color2.Text = "Couleur ligne 2";
			// 
			// apply
			// 
			this.apply.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.apply.Location = new System.Drawing.Point(176, 152);
			this.apply.Name = "apply";
			this.apply.Size = new System.Drawing.Size(112, 23);
			this.apply.TabIndex = 4;
			this.apply.Text = "Appliquer";
			// 
			// PrefColorsPage
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.BackColor = System.Drawing.Color.WhiteSmoke;
			this.ClientSize = new System.Drawing.Size(306, 184);
			this.Controls.Add(this.apply);
			this.Controls.Add(this.viewColor2);
			this.Controls.Add(this.color2);
			this.Controls.Add(this.viewColor1);
			this.Controls.Add(this.color1);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "PrefColorsPage";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Slection des couleurs...";
			this.ResumeLayout(false);

		}
		#endregion

		private void OnSave(object sender, EventArgs e)
		{
			this.DialogResult = DialogResult.OK;
		}

		/// <summary>
		/// Selection de la couleur.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnChooseColor1(object sender, EventArgs e)
		{
			Color c = ShowColorDialog(Color1);
			if(c != Color.Empty)
			{
				Color1 = c;
			}
		}

		/// <summary>
		/// Selection de la couleur alternative.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnChooseColor2(object sender, EventArgs e)
		{
			Color c = ShowColorDialog(Color2);
			if(c != Color.Empty)
			{
				Color2 = c;
			}
		}
	}
}
